swap_config="/data/swap_config.conf"
function get_prop() {
  cat $swap_config | grep -v '^#' | grep "^$1=" | cut -f2 -d '='
}


# get_prop prop
# 解析配置
auto_cgroup=$(get_prop auto_cgroup)

if [[ "$auto_cgroup" != "true" ]]; then
  echo '未启用cgroup更改'
  exit 0
fi

white_list_enable=true
auto_cpuset=true

function set_white_list() {
  echo "*************************"
  if [[ "$white_list_enable" == "true" ]]; then
    echo ""
    echo "设置白名单"


    echo "  等待系统启动完成"
    while [ 1 = 1 ]
    do
      sleep 3
      boot_completed=$(getprop sys.boot_completed)
      if [[ "$boot_completed" == "1" ]]; then
        break
      fi
    done

    echo "  系统已启动完成"
    sleep 90 # 先等一会再执行后面的操作

    launcher_app=""
    sdk=$(getprop ro.build.version.sdk)
    if [[ "$sdk" -gt 27 ]]; then
      # 获取默认桌面
      launcher_app=`pm resolve-activity --brief -c android.intent.category.HOME -a android.intent.action.MAIN | grep '/' | cut -f1 -d '/'`
      echo "  获得默认桌面：" $launcher_app
    fi

    # 如果正确获取到桌面，等待桌面启动再去设置白名单
    if [[ "$launcher_app" != "" ]] && [[ "$launcher_app" != "android" ]]; then
      while [ 1 = 1 ]; do
        sleep 10
        launcher_pid=$(pgrep -f $launcher_app | head -1)
        if [[ "$launcher_pid" != "" ]]; then
          echo "  已获取到桌面进程"
          break
        else
          echo "  未获取到桌面进程"
        fi
      done
    fi

    source /system/bin/scene_memcg.sh
  fi
}


function auto_cpuset()
{
    if [[ "$auto_cpuset" == "true" ]]; then
      echo ""
      echo "设置cpuset"
      source /system/bin/scene_cpuset.sh
    fi
}

sleep 20

set_white_list
auto_cpuset
