#   ** 将一些对体验影响较大应用添加到系统应用组
#   ** 并尽量避免这些应用的内存被交换到SWAP/ZRAM

# launcher_app=$1

# 如果不支持就不用往下走了
config_dir=""
config_path=""
config_dir1="/sys/fs/cgroup/memory"
config_dir2="/dev/memcg"
if [[ -d $config_dir1 ]]; then
  config_dir=$config_dir1
elif [[ -d $config_dir2 ]]; then
  config_dir=$config_dir2
else
  echo "  你的手机不支持按应用设置swappiness"
  return
fi


init_group() {
  local g=$config_dir/$1
  if [[ ! -d $g ]]; then
    mkdir $g
  fi
  echo $2 > $g/memory.swappiness
  echo 1 > $g/memory.oom_control
  echo 1 > $g/memory.move_charge_at_immigrate
}


if [[ "$config_dir" != "" ]]; then
  init_group scene_lock 100
  init_group scene_perf 10
  init_group scene_sys 0
  echo 1 > $config_dir/memory.move_charge_at_immigrate
fi


config_dir="$config_dir/scene_sys"
config_path="$config_dir/tasks"

sleep 2

white_list()
{
  echo -n "  + $1 "
  # pgrep 精确度有点差
  pgrep -f $1 | while read pid; do
    echo -n "$pid "
    echo $pid > $config_path
  done
  echo ""
}

# MIUI 版本
miui_version=`getprop ro.miui.ui.version.name`


# surfaceflinger
white_list surfaceflinger
# 系统服务
# white_list system_server
# zygote
# white_list zygote
# lmkd
white_list lmkd
# mediaserver（媒体服务）
white_list mediaserver
# audioserver（音频服务）
white_list audioserver
# android.hardware.graphics.composer(硬件叠加层)
white_list android.hardware.graphics.composer
white_list vendor.qti.hardware.display.composer-service
white_list com.android.permissioncontroller
# android.hardware.audio(音频)
white_list android.hardware.audio
# 蓝牙
white_list com.android.bluetooth
# android.hardware.bluetooth(蓝牙)
white_list android.hardware.bluetooth
# android.hardware.sensors(传感器)
white_list android.hardware.sensors
# mediaswcodec(编解码器)
white_list mediaswcodec
# media.codec(编解码器)
white_list media.codec
# netmgrd
# white_list netmgrd
# netd
# white_list netd

# 系统System
white_list com.android.systemui
# 媒体存储
white_list android.process.media
# MTP主机
white_list com.android.mtp
# Gesture(第三方)手势
white_list com.omarea.gesture
# 记得动画壁纸（第三方）
white_list com.srm.blurscalewallpaper
# 搜狗输入法
white_list com.sohu.inputmethod.sogou

# 如果MIUI版本信息不为空，那就是MIUI了
if [[ "$miui_version" != "" ]]; then
  # MIUI 桌面
  white_list com.miui.home
  # 搜狗输入法 小米版
  white_list com.sohu.inputmethod.sogou.xiaomi
  # 百度输入法 小米版
  white_list com.baidu.input_mi
  # 讯飞输入法 小米版
  white_list com.iflytek.inputmethod.miui
  # 游戏加速VPN
  white_list com.miui.vpnsdkmanager
  # 自由窗口
  # white_list com.miui.freeform
  # 通知管理
  white_list com.miui.notification
  # 万象息屏、息屏指纹
  white_list com.miui.aod
fi

# 添加桌面为白名单
if [[ "$launcher_app" ]]; then
  white_list "$launcher_app"
fi

echo ""
echo "已添加的白名单进程"
cat $config_path
echo ""
